/**
 * JORM: an implementation of a generic mapping system for persistent Java
 *       objects. Two mappings are supported: to RDBMS and to binary files.
 * Copyright (C) 2001-2004 France Telecom R&D - INRIA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: jorm-team@objectweb.org
 *
 */

package jorm;

import org.objectweb.jorm.api.PAccessor;
import org.objectweb.jorm.api.PException;
import org.objectweb.jorm.naming.api.PName;

public interface Olstore_itemAccessor extends PAccessor {

	//Accessors to the itemId field
	public void paSetItemId(java.lang.Integer val) throws PException;
	public java.lang.Integer paGetItemId() throws PException;

	//Accessors to the jonasCMROrder_Item field
	public void paSetJonasCMROrder_Item(PName val, Object connection) throws PException;
	public PName paGetJonasCMROrder_Item(Object connection) throws PException;

	//Accessors to the jonasCMRUser_Item field
	public void paSetJonasCMRUser_Item(PName val, Object connection) throws PException;
	public PName paGetJonasCMRUser_Item(Object connection) throws PException;

	//Accessors to the longDesc field
	public void paSetLongDesc(java.lang.String val) throws PException;
	public java.lang.String paGetLongDesc() throws PException;

	//Accessors to the mainPage field
	public void paSetMainPage(java.lang.Boolean val) throws PException;
	public java.lang.Boolean paGetMainPage() throws PException;

	//Accessors to the name field
	public void paSetName(java.lang.String val) throws PException;
	public java.lang.String paGetName() throws PException;

	//Accessors to the pictures field
	public void paSetPictures(PName val, Object connection) throws PException;
	public PName paGetPictures(Object connection) throws PException;

	//Accessors to the price field
	public void paSetPrice(java.math.BigDecimal val) throws PException;
	public java.math.BigDecimal paGetPrice() throws PException;

	//Accessors to the properties field
	public void paSetProperties(PName val, Object connection) throws PException;
	public PName paGetProperties(Object connection) throws PException;

	//Accessors to the shortDesc field
	public void paSetShortDesc(java.lang.String val) throws PException;
	public java.lang.String paGetShortDesc() throws PException;

	//Accessors to the specialOffer field
	public void paSetSpecialOffer(java.lang.Boolean val) throws PException;
	public java.lang.Boolean paGetSpecialOffer() throws PException;

	//Accessors to the typeId field
	public void paSetTypeId(PName val, Object connection) throws PException;
	public PName paGetTypeId(Object connection) throws PException;
}
