/**
 * JORM: an implementation of a generic mapping system for persistent Java
 *       objects. Two mappings are supported: to RDBMS and to binary files.
 * Copyright (C) 2001-2004 France Telecom R&D - INRIA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: jorm-team@objectweb.org
 *
 */

package jorm;

import org.objectweb.jorm.naming.api.PBinder;
import org.objectweb.jorm.naming.api.PExceptionNaming;
import org.objectweb.jorm.api.PExceptionProtocol;
import org.objectweb.jorm.api.PException;
import org.objectweb.jorm.naming.api.PName;
import org.objectweb.jorm.naming.api.PNameCoder;
import org.objectweb.jorm.api.PSerializable;
import org.objectweb.jorm.api.PAccessor;
import org.objectweb.jorm.api.PAccessorGen;
import org.objectweb.jorm.api.PClassMapping;

public class Olstore_orderSerializable implements PSerializable, Olstore_orderAccessor {

	//the pname of the object
	protected String pName;
	
		protected java.lang.String dateReceived;
			protected  String item;
			protected java.lang.Integer orderId;
			protected java.math.BigDecimal pricePaid;
			protected java.lang.Integer quantity;
			protected java.lang.String status;
			protected  String user;
	
	public String setPName(PName pName){
		if(pName.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				this.pName  = pName.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			this.pName = "null";
		}
		return this.pName;
	}
	
	public PName getPName(PBinder pnc) throws PExceptionNaming{
		try{
			return pnc.decodeString(pName);
		}catch (Exception e) {
              throw new PExceptionNaming("Cannot decode to a PName: " + e.getMessage());
        }
	}
	
	public String getClassName(){
		return "jorm.Olstore_order";
	}
	

	public void paSetDateReceived(java.lang.String val){
		dateReceived = val;
	}
	public java.lang.String paGetDateReceived() {
		return dateReceived;
	}

	public void paSetItem(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				item = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			item = "null";
		}
	}
	
	public PName paGetItem(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("item");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(item);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetOrderId(java.lang.Integer val){
		orderId = val;
	}
	public java.lang.Integer paGetOrderId() {
		return orderId;
	}

	public void paSetPricePaid(java.math.BigDecimal val){
		pricePaid = val;
	}
	public java.math.BigDecimal paGetPricePaid() {
		return pricePaid;
	}

	public void paSetQuantity(java.lang.Integer val){
		quantity = val;
	}
	public java.lang.Integer paGetQuantity() {
		return quantity;
	}

	public void paSetStatus(java.lang.String val){
		status = val;
	}
	public java.lang.String paGetStatus() {
		return status;
	}

	public void paSetUser(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				user = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			user = "null";
		}
	}
	
	public PName paGetUser(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("user");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(user);
		}
		catch(PException e){
			return null;
		}
	}

	public Object getMemoryInstance(){
		return this;
	}
	
	
	public String toString(){
		StringBuffer s = new StringBuffer();
		s.append("data(");
					s.append(dateReceived + ",  ");
					s.append(item + ",  ");
					s.append(orderId + ",  ");
					s.append(pricePaid + ",  ");
					s.append(quantity + ",  ");
					s.append(status + ",  ");
					s.append(user + ",  ");
				s.append(pName + ")");
		return s.toString();
	}
	
	
	public void read(PClassMapping pcm, PAccessor pa) throws PException{
		Olstore_orderAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PException("Accessor must not be null");
		else if (pa instanceof Olstore_orderAccessor)
			paccessor = (Olstore_orderAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PException("Wrong type of accessor: " + pa);
	 	try {	
			if(paccessor != null){
											paccessor.paSetDateReceived(paGetDateReceived());
															paccessor.paSetItem(paGetItem(pcm), null);
															paccessor.paSetOrderId(paGetOrderId());
															paccessor.paSetPricePaid(paGetPricePaid());
															paccessor.paSetQuantity(paGetQuantity());
															paccessor.paSetStatus(paGetStatus());
															paccessor.paSetUser(paGetUser(pcm), null);
							 			}
 			else{
	  		 			        		//paccessorGen.paSetStringField("dateReceived", paGetDateReceived(pcm), null);
	        			 						 			        		//paccessorGen.paSetOintField("orderId", paGetOrderId(pcm), null);
	        			 			        		//paccessorGen.paSetBigDecimalField("pricePaid", paGetPricePaid(pcm), null);
	        			 			        		//paccessorGen.paSetOintField("quantity", paGetQuantity(pcm), null);
	        			 			        		//paccessorGen.paSetStringField("status", paGetStatus(pcm), null);
	        			 						        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
	
	public void write(PClassMapping pcm, PAccessor pa) throws PException{
		Olstore_orderAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PExceptionProtocol("Accessor must not be null");
		else if (pa instanceof Olstore_orderAccessor)
			paccessor = (Olstore_orderAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PExceptionProtocol("Wrong type of accessor: " + pa);
		try {	
			if(paccessor != null){
											paSetDateReceived(paccessor.paGetDateReceived());
															paSetItem(paccessor.paGetItem(pcm), null);
															paSetOrderId(paccessor.paGetOrderId());
															paSetPricePaid(paccessor.paGetPricePaid());
															paSetQuantity(paccessor.paGetQuantity());
															paSetStatus(paccessor.paGetStatus());
															paSetUser(paccessor.paGetUser(pcm), null);
							 			}
 			else{
	  		 				        	//	paSetStringField(dateReceived, paccessorGen.paGetDateReceived());
        		//paSetStringField("dateReceived", paccessorGen.paGetStringField("dateReceived"));
        		//paSetDateReceived(paccessorGen.paGetStringField("dateReceived"), null);
	        			 						 				        	//	paSetOintField(orderId, paccessorGen.paGetOrderId());
        		//paSetOintField("orderId", paccessorGen.paGetOintField("orderId"));
        		//paSetOrderId(paccessorGen.paGetOintField("orderId"), null);
	        			 				        	//	paSetBigDecimalField(pricePaid, paccessorGen.paGetPricePaid());
        		//paSetBigDecimalField("pricePaid", paccessorGen.paGetBigDecimalField("pricePaid"));
        		//paSetPricePaid(paccessorGen.paGetBigDecimalField("pricePaid"), null);
	        			 				        	//	paSetOintField(quantity, paccessorGen.paGetQuantity());
        		//paSetOintField("quantity", paccessorGen.paGetOintField("quantity"));
        		//paSetQuantity(paccessorGen.paGetOintField("quantity"), null);
	        			 				        	//	paSetStringField(status, paccessorGen.paGetStatus());
        		//paSetStringField("status", paccessorGen.paGetStringField("status"));
        		//paSetStatus(paccessorGen.paGetStringField("status"), null);
	        			 						        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
}